/* Demonstraatioita C-kielen tyypeistä, erityisesti tietuetyyppi
 * eli 'struktuuri'.
 *
 * Käyttöjärjestelmät -- kesä 2011 / Paavo Nieminen, JYU TTL
 * <nieminen@jyu.fi>
 *
 * HUOM: Tämän ohjelman kääntäminen tarvitsee
 *       perusmatematiikkakirjaston. Tarvittu käännöskomento on siis:
 *
 *          gcc -lm tietue.c 
 *
 *       jossa argumentti -lm aiheuttaa libm.a -nimisen kirjaston
 *       linkittämisen.  Materiaalin liitteessä "C-kääntäjän
 *       sielunelämä" yritetään selittää kirjastoista,
 *       objektitiedostoista ja .h -tiedostoista.
 * 
 * Idea: - tutustu tähän koodiin lukemalla sitä ja kommentteja.
 *       - koeta ymmärtää mistä on kyse.
 *       - kokeile vapaasti, miten asiat toimivat, eli muunna, 
 *         käännä, aja
 *       - tee tehtävät; sen pitäisi onnistua, jos tämän demon 
 *         opetustavoite toteutuu
 *       - jos materiaali on epäselvä jostain kohtaa, kerro heti,
 *         niin koetan selkeyttää sitä.
 *
 * Tehtävä: 
 *
 * - toteuta aliohjelma, joka laskee kahden vect3d_t -tyyppisen
 *   (osoittimina annetun) tietueen pistetulon ja palauttaa sen
 *   doublena. Pistetulohan on matemaattisesti kaava x1*x2 + y1*y2 +
 *   z1*z2 vektorien (x1,y1,z1) ja (x2,y2,z2) välillä.
 *
 * - tee pääohjelmaan testi, jossa teet toisen vektorin, ja lasket
 *   ja tulostat kahden vektorin pistetulon.
 *
 */

#include<stdio.h>
#include<math.h>

/* Tässä määritellään tietuetyyppi, jolla voidaan esittää
 * kolmiulotteisen avaruuden vektori.
 */
typedef struct {
  double x,y,z;
} vect3d_t;

/* Laskee vektorin euklidisen normin. 
 * Huomaa taas tähti-syntaksi osoitintyyppiselle parametrille.
 */
double vect3d_norm(vect3d_t *v){
  double normsq;
  /* Osoittimen kautta pääsee tietueen kenttiin käsiksi "nuolella" eli
   * -> seuraavasti:
   */
  normsq = (v->x)*(v->x) + (v->y)*(v->y) + (v->z)*(v->z);
  return sqrt(normsq);
}

int main(int argc, char **argv){
  vect3d_t piste = {1.0, 2.0, 3.4};

  /*Huomaa, että nyt on varattu tietueelle tilaa pinosta. Aliohjelmaan
  * vaaditaan osoitin, joten käytetään "reference operatoria" eli
  * viitteen ottamista eli pointterin tekemistä muuttujaan. Se on tuo
  * syntaksi &piste tuolla. Siis et-merkillä merkitty operaattori &
  * ottaa oikealla puolellaan olevan muuttujan muistiosoitteen, jonka
  * voi sijoittaa sopivaan osoitinmuuttujaan:
  */
  printf("Pisteen koordinaatit (%.4f %.4f %.4f), etäisyys origosta %.4f\n",
         piste.x, piste.y, piste.z, vect3d_norm(&piste));

  /*(Jossain vaiheessa, btw, jos ei vielä ole tullut vastaan,
   * kannattaa opetella printf:n toiminta -- se kun nykyään jo löytyy
   * ihan Javastakin.)
   */
  return 0;
}
