// -*- coding:utf-8 -*-
/**
 * Mallikoodia kevään 2015 kurssin ITKA203 Käyttöjärjestelmät demoon 3.
 * Tätä on käytelty mukavasti sen jälkeenkin.
 * Pieni pedagoginen lisäpäivitys 2021: Ympäristömuuttuja,
 * jota ei ole defaulttina kellään valmiina.
 */

#include<stdio.h>
#include<stdlib.h>

#define MIN_MERKKEJA_FIILIKSESSA 4
#define MAX_MERKKEJA_FIILIKSESSA 1000

void tulosta_ohje(){
    printf("\nOhje\n====\n\n"
           "Tämä ohjelma tulostaa tietoja käyttäjästä ja suoritusympäristöstä.\n\n"
           "Demon 3 palautuksen yhteydessä sinun tulee ajaa ohjelma JY:n\n"
           "IT-palveluiden suorakäyttökoneella ja antaa yksi argumentti,\n"
           "jossa kuvailet tunnelmiasi kurssin tässä vaiheessa. Yksi sana\n"
           "ei riitä, vaan argumentissa on oltava vähintään yksi välilyönti\n"
           "ja sen pituus pitää olla vähintään %d merkkiä, joten \"eos\" ei käy.\n\n"
           "Lisäksi ympäristön kieliasetusten täytyy olla tämän ohjelman \n"
           "suoritusvaiheessa englanninkielinen. (Syy: Esimerkiksi kääntäjän\n"
           "varoitukset ja virheviestit eivät ole aina aivan selkeitä suomeksi,\n"
           "ja lisätietojen etsimiseksi Internetistä on syytä hakea englanniksi\n"
           "joka tapauksessa... täytyy osata säätää tämä!)\n\n"
           "Lisäksi pitää asettaa yksi sellainen ympäristömuuttuja, jolla\n"
           "ei varmastikaan ole oletuksena asetettua arvoa käyttöjärjestelmässä.\n\n"
           "Demovastaus on tekstitiedosto, nimeltään d3_vastaus.txt, johon\n"
           "olet ohjannut tämän ohjelman tulosteen suorakäyttökoneen kuoressa.\n\n",
           MIN_MERKKEJA_FIILIKSESSA);
}

int sisaltaa_valilyonnin_ja_on_pitka(const char *mjono){
    int i;
    int vlyonteja = 0;
    for(i=0;i<MAX_MERKKEJA_FIILIKSESSA;i++){
        if (mjono[i] == '\0') break;
        if (mjono[i]==' ') vlyonteja++;
    }
    return (vlyonteja >= 1) && (i >= MIN_MERKKEJA_FIILIKSESSA);
}

void tulosta_vain_jos_asetettu(const char *env_name){
    char *value = getenv(env_name);
    if(value != NULL) {
      printf("Ympäristömuuttuja %s == %s\n",env_name,value);
    }
}

void varoita_jos_ei_asetettu(const char *env_name){
    char *value = getenv(env_name);
    if (value == NULL) {
        printf("VAROITUS: Ympäristömuuttujaa %s ei ole asetettu! Tarkista demo-ohje vielä.\n", env_name);
    }
}

void tulosta_tietoja_ymparistosta(){
    printf("Ympäristömuuttuja USER   == %s\n",getenv("USER"));
    printf("Ympäristömuuttuja HOME   == %s\n",getenv("HOME"));
    printf("Ympäristömuuttuja PWD    == %s\n",getenv("PWD"));
    tulosta_vain_jos_asetettu("LC_ALL");
    tulosta_vain_jos_asetettu("LC_COLLATE");
    tulosta_vain_jos_asetettu("LC_CTYPE");
    tulosta_vain_jos_asetettu("LC_MESSAGES");
    tulosta_vain_jos_asetettu("LC_MONETARY");
    tulosta_vain_jos_asetettu("LC_NUMERIC");
    tulosta_vain_jos_asetettu("LC_TIME");
    tulosta_vain_jos_asetettu("LANG");
    tulosta_vain_jos_asetettu("LEMPIKALA");
}

void tulosta_argumentit(int argc, char *argv[]){
    for (int i=0;i<argc;i++){
        printf("argv[%d] == %s\n",i,argv[i]);
    }
    const char *usr = getenv("USER");
    printf("Kertauksena: käyttäjän '%s' tunnelmat tässä vaiheessa kurssia:\n\n",usr);
    printf("%s\n\n",argv[1]);
}

int main(int argc, char *argv[]){
    if (argc<2) {
        tulosta_ohje();
        return EXIT_SUCCESS;
    }
    if (!sisaltaa_valilyonnin_ja_on_pitka(argv[1])){
        printf("ONGELMA: Liian lyhyt tai vähäsanainen tunnelmakuvaus!\n\n");
        tulosta_ohje();
        exit(EXIT_FAILURE);
    }
    tulosta_tietoja_ymparistosta();
    tulosta_argumentit(argc, argv);
    varoita_jos_ei_asetettu("LEMPIKALA");
    return EXIT_SUCCESS;
}
