/*
 * Yksinkertainen C-kielinen ohjelma: laskee rekursiivisesti luvun
 * kertoman ja tulostaa sen standardiulostuloon. Käytetään int64_t
 * -tyyppiä, niin luvut on saman mittaisia kuin muistiosoitteet
 * (debuggerin tuloste näyttää nätimmältä siten).
 *
 * Luennolla (2014) käännettiin tämä ja ihmeteltiin syntynyttä
 * konekielistä ohjelmaa gdb-debuggerin disassemblynä. Ajettiin
 * lähdekoodirivi kerrallaan step-komennolla, ja havainnoitiin
 * aliohjelma-aktivaatioiden syntymistä kutsupinoon.
 *
 */
#include<stdio.h>
#include<stdint.h>
#include<inttypes.h>

/** Palauttaa luvun n kertoman, eli esim. 9! = 9x8x7x6x5x4x3x2x1 */
int64_t kertoma(int64_t n){
  int64_t edellinen;
  if (n==0) return 1;
  edellinen = kertoma(n-1);
  return n*edellinen;
}

int64_t laske_ja_tulosta_kertoma(int64_t n){
  int64_t tulos;
  tulos = kertoma(n);
  printf("Luvun %" PRId64 " kertoma on %" PRId64 ".\n", n, tulos);
  return tulos;
}

/** Ns. "Pääohjelma" */
int main(int argc, char** argv){
  int64_t luku, vastaus;
  luku = 9;
  vastaus = laske_ja_tulosta_kertoma(luku);
  return 0;
}
