
/** liit  - liittää tiedostoja peräkkäin. 
 * 
 * Vähän niinkuin cat, mutta karvahattumalli ja suomenkielinen :)
 * 
 * Käyttää C:n rajapintaa (ei "sinänsä" käyttöjärjestelmän, mutta
 * POSIX sisältää C99 -rajapinnan, joten fopen() on toki käytettävissä
 * POSIX-järjestelmissä).
 */
#include<stdio.h>
#include<stdlib.h>

int main(int argc, char *argv[]) {
    if (argc < 2) {
        fprintf(stderr, "Ei katenoitavaa.\n");
        fprintf(stderr, "Käyttö: %s TIEDOSTONIMI [TIEDOSTONIMI]\n");
        exit(1);
    }

    for (int i=1; i<argc; i++) {
        FILE *virta = fopen(argv[i], "r");
        if (virta == NULL) {
            perror("Ei saatu auki");
            fprintf(stderr, "Skipataan %s\n",argv[i]);
            continue;
        }
        
        while (1) {
            int byte = fgetc(virta);
            if (byte == EOF) {
                if (feof(virta)) { break; /* OK: tiedoston loppu tavoitettu */ }
                else { perror("Lukuvirhe"); continue; /* Muu häikkä */ }
            }
            if (fputc(byte, stdout) == EOF) {
                perror("Kirjoitusvirhe");
            }
        }
        fclose(virta);
    }

    return 0;
}
